jQuery.fn.fe = function (a, b) {
  if (!b || b.constructor != Array) {
    b = new Array()
  }
  $(this).each(function (c) {
    var d = (this.id) ? this.id : b.length;
    b[d] = new FE(this, a || {})
  });
  return b
};

var FE = function(a, b){
	this.width = b.width || $(a).width() || '100%';
  	this.height = b.height || $(a).height() || 350;  	
	this.tbitem = b.tbitem || {};
	this.statusbar = b.statusbar || false;
	this.toolbar = typeof b.toolbar == 'undefined' ? true : b.toolbar;
	this.save = b.save || function(){};
	this.cancel = b.cancel || false;
	this.border = b.border || 1;
	this.param = b.param;
	
	if (document.designMode || document.contentEditable) {
		$(a).wrap($('<div/>').addClass('fe-zone').width(this.width).css('border-width',this.border+'px').css('border-color','#ccc'));
		
		this.textarea = a;
		this.enable_design_mode();
	}
}

FE.prototype.gethtml = function(){
	var d = this;
	var html = '';
	if(typeof d.tbitem.title == 'undefined'){
		return '正在加载数据..';	
	}
	html += '<img width="300" src="' + d.tbitem.imgurl + '"/>';
	html += '<br/>';
	html += d.tbitem.prolink;
	html += '<br/>';
	html += d.tbitem.title;
	html += '<br/>';
	html += '原价：' + d.tbitem.oldprice + '&nbsp;&nbsp;&nbsp;&nbsp;' + '拍下特价：' + d.tbitem.newprice;
	html += '<br/>';
	
	return html;
}

FE.prototype.content = function(cont){
	if(cont)
		$('body', this.iframe_doc).html(cont);
	else
		return $('body', this.iframe_doc).html();
}

FE.prototype.enable_design_mode = function () {
	var a = this;
	a.iframe = document.createElement('iframe');
	a.iframe.frameBorder = 0;
	a.iframe.frameMargin = 0;
	a.iframe.framePadding = 0;
	a.iframe.width = '100%';
	a.iframe.height = a.height || '100%';
	a.iframe.src = 'javascript:void(0);';	
	if ($(a.textarea).attr('class')) {
	a.iframe.className = $(a.textarea).attr('class')
	}
	if ($(a.textarea).attr('id')) {
	a.iframe.id = $(a.textarea).attr('id');
	}
	if ($(a.textarea).attr('name')) {
	a.iframe.title = $(a.textarea).attr('name')
	}
	var f = $(a.textarea).val();

	$(a.textarea).hide().after(a.iframe).remove();
	a.textarea = null;

	var c = '<style>*{margin:0; padding:0; line-height:26px;} body{padding:5px 5px; white-space: pre-wrap;word-wrap: break-word;font-size: 14px; font-family:\'微软雅黑\';}</style>';
	var j = '<html><head>' + c + '</head><body>' + f + '</body></html>';
	a.iframe_doc = a.iframe.contentWindow.document;
	try {
	a.iframe_doc.designMode = 'on'
	} catch (h) {
	$(a.iframe_doc).focus(function () {
	  a.iframe_doc.designMode()
	})
	}
	a.iframe_doc.open();
	a.iframe_doc.write(j);
	a.iframe_doc.close();
	
	if(a.toolbar)
		a.create_toolbar();
		
	if(a.statusbar == true)
		a.create_statusbar();

	$(a.iframe_doc).mouseup(function (e) {
		if (a.iframe_doc.selection) {
		  a.range = a.iframe_doc.selection.createRange()
		}	
	});
	$(a.iframe_doc).blur(function (e) {
	if (a.iframe_doc.selection) {
	  a.range = a.iframe_doc.selection.createRange()
	}
	});

	$(a.iframe_doc).keyup(function (e) {
	if (a.iframe_doc.selection) {
	  a.range = a.iframe_doc.selection.createRange()
	}	
	});
	
	$(a.iframe_doc).keydown(function (e) {
		//if(e.which == 86){
//			$.get('tran.fsp',{'action':'getdata'}, function(data){
//				alert(data);	
//			});
//			return false;
//		}
	});
	
	if (!$.browser.msie) {
		a.editor_cmd('styleWithCSS', false)
	}	
};

FE.prototype.get_selection_range = function () {
  var a = null;
  var c = this.iframe.contentWindow;
  this.iframe.focus();
  if (c.getSelection) {
    a = c.getSelection().getRangeAt(0);
    if ($.browser.opera) {
      var b = a.startContainer;
      if (b.nodeType === Node.TEXT_NODE) {
        a.setStartBefore(b.parentNode)
      }
    }
  } else {
	this.range.select();
    a = this.iframe_doc.selection.createRange();
  }
  return a
};

FE.prototype.get_selection_text = function(){
	this.iframe.contentWindow.focus();
	var c = this.iframe.contentWindow;
	if (c.getSelection) {
		a = c.getSelection().getRangeAt(0);
		if ($.browser.opera) {
			var b = a.startContainer;
			if (b.nodeType === Node.TEXT_NODE) {
				a.setStartBefore(b.parentNode)
			}
		}
		
		return a.toString();
	} else {		
		a = this.iframe_doc.selection.createRange();
		return a.text;
	}
}

FE.prototype.editor_cmd = function (c, a) {
  this.iframe.contentWindow.focus();
  try {
    this.iframe_doc.execCommand(c, false, a)
  } catch (b) {
  }
  this.iframe.contentWindow.focus()
};

FE.prototype.insert_html = function(cont, e){
	this.iframe.contentWindow.focus();
	if($.browser.msie){
		if(typeof this.range == 'undefined'){
			this.range = this.iframe_doc.selection.createRange();
		}
		
		this.range.pasteHTML(cont);
		this.range.moveStart('character',0);
		this.range.collapse();
		this.range.select();	
	}
	else{
		this.editor_cmd('inserthtml', cont);
	}
}

FE.prototype.create_toolbar = function(){
	var c = this;
	var b = $('<div></div>').addClass('fe-toolbar').width('100%').append($('<ul></ul>')).append($('<div></div>').addClass('clear'));
	var l;
	
	var face = $('<a href=\'#\'></a>').attr('title', '插入表情').attr('rel', 'image').click(function (i) {
		if(typeof $('.fe-face-panel')[0] != 'undefined')
			return false;
		c.create_face_panel();
		return false;
    });
	l = $('<li/>').append(face.addClass('face'));
	$('ul', b).append(l);
	
	var uploadimg = $('<a href=\'#\'></a>').attr('title', '插入图片').attr('rel', 'uploadimg').click(function (i) {
		if(typeof $('.fe-upload-panel')[0] != 'undefined')
			return false;		
		
		c.upload_panel = c.create_upload_panel();		
		return false;
	});
	l = $('<li/>').append(uploadimg.addClass('uploadimg'));
	$('ul', b).append(l);
	
	var tranlink = $('<a href=\'#\'></a>').attr('title', '转换链接').attr('rel', 'tranlink').click(function (i) {
		var url = c.get_selection_text();
		if(typeof url == 'undefined' || url == ''){
			alert('请选中要转转换链接！');
			return false;
		}		
		
		/*$.get('urltrans.fsp',{'url':url}, function(data){
			c.insert_html('<a href=' + data + '>'+data+'</a>', i);
		});*/
		c.mask_panel = c.create_mask_panel();
		c.progress_panel = c.create_progress_panel();
		$.get('urltrans.fsp',{'url':url,'t':Math.random()}, function(data){
			data = eval('('+ data +')');
			c.mask_panel.remove();
			c.progress_panel.remove();
			if(data.ok){
				c.insert_html('<a href="' + data.prolink + '">' + data.prolink + '</a>', i);
			}else{
				alert(data.message);	
			}			
		});
		
		return false;
	});
	l = $('<li/>').append(tranlink.addClass('tranlink'));
	$('ul', b).append(l);
	
	if(typeof c.tbitem.imgurl != 'undefined'){
		var img = $('<a href=\'#\'></a>').attr('title', '插入主图').attr('rel', 'image').click(function (i) {
			  c.insert_html('<img width="300" src="' + c.tbitem.imgurl + '" />', i);
			  return false;
		});
		l = $('<li/>').append(img.addClass('image'));
		$('ul', b).append(l);
	}
	
	if(typeof c.tbitem.prolink != 'undefined'){
		var href = $('<a href=\'#\'></a>').attr('title', '插入推广链接').attr('rel', 'href').click(function (i) {
			  c.insert_html(c.tbitem.prolink, i);
			  return false;
		});
		l = $('<li/>').append(href.addClass('href'));
		$('ul', b).append(l);
	}
	
	if(typeof c.tbitem.title != 'undefined'){
		var title = $('<a href=\'#\'></a>').attr('title', '插入标题').attr('rel', 'title').click(function (i) {
			  c.insert_html(c.tbitem.title, i);
			  return false;
		});
		l = $('<li/>').append(title.addClass('title'));
		$('ul', b).append(l);
	}	
	
	if(c.cancel == true){
		var cancel = $('<span/>').html('关闭窗口').attr('title', '关闭窗口').attr('rel', 'cancel').click(function (i) {
			 $('.fe-zone').remove();
			 return false;
		});
		l = $('<li/>').css('float','right').append(cancel.addClass('send'));
		$('ul', b).append(l);
	}
	
	var send = $('<span/>').html('保存发送').attr('title', '保存发送').attr('rel', 'send').click(function (i) {
		  if(typeof c.save == 'function'){
			if(c.send.html() == '保存中..')
				return;
			c.send.html('保存中..');
			c.save(c,c.param);
		  }
		  return false;
    });
	c.send = send;
	l = $('<li/>').css('float','right').append(send.addClass('send'));
	$('ul', b).append(l);
	
	c.toolbar = b;	
	$(c.iframe).before(b);
}

FE.prototype.create_statusbar = function(){
	var s = this;
	var b = $('<div></div>').addClass('fe-statusbar').append($('<div></div>').addClass('clear'));
	
	var oldp = $('<span/>').addClass('oldp').html('宝贝原价：￥' + s.tbitem.oldprice);
	b.append(oldp);
	
	var newp = $('<span/>').addClass('newp').html('特价：<i>￥' + s.tbitem.newprice + '</i>');
	b.append(newp);
	
	s.statusbar = b;
	$(s.iframe).after(b);	
}

FE.prototype.create_face_panel = function(){
	var p = this;
	var x = p.iframe.offsetLeft - 1;
	var y = p.iframe.offsetTop -1;
	var a = $('<div/>').hide().addClass('fe-face-panel').css({
		left: x,
		top: y
	});
	
	var tbl = $('<table/>');
	var tbd = $('<tbody/>');
	var index = 0;
	for(var i = 0; i < 8; i++){
		var tr = $('<tr/>');
		for(var j = 0; j < 15; j++){
			var td = $('<td/>');
			var aa = $('<a/>').attr('index', index++);
			aa.css('background-position','-'+ (j*24 + i*360) +'px 0');
			aa.bind(
				'mouseover',function(){$(this).css('border','1px solid #00f');}
			).bind(
				'mouseout',function(){$(this).css('border','1px solid #fff');}
			).bind(
				'click',function(){					
					p.insert_html('<img src="./images/emoticons/'+ $(this).attr('index') +'.gif" />');
					a.remove();
					return false;
				}
			);
			td.append(aa);
			tr.append(td);
		}
		tbd.append(tr);
	}
	tbl.append(tbd);
	
	a.append(tbl);
	p.toolbar.append(a);
	a.show();
}

FE.prototype.create_upload_panel = function(){
	var p = this;	
	var x = p.iframe.offsetLeft + (p.iframe.offsetWidth - 316)/2;
	var y = p.iframe.offsetTop + (p.iframe.offsetHeight - 120)/2 - 100;
	var a = $('<div/>').hide().addClass('fe-upload-panel').css({
		left: x,
		top: y
	});
	
	var title_wp = $('<div/>').addClass('title_wp');
	var title = $('<span/>').addClass('title').html('请选择文件');
	var cls = $('<a/>').addClass('close').click(function(){
		if($('#fe-upload-panel-form').attr('uploading')){
			return;
		}
		a.remove();										 
	});
	title_wp.append(cls).append(title);
	a.append(title_wp);
	
	var bd = $('<div/>').addClass('bd');
	a.append(bd);
	
	var iframe = $('<iframe name="upload_file_iframe" width="0" height="0" frameborder="0"/>');
	bd.append(iframe);
	
	var form = $('<form id="fe-upload-panel-form" method="post" enctype="multipart/form-data" target="upload_file_iframe" action="upload.fsp"/>');
	bd.append(form);
	
	var file = $('<div/>').addClass('upload-file').append($('<span/>').html('请选择文件')).append($('<input id="upload_file" type="file" name="file"/>'));
	form.append(file);
	
	var ok = $('<input id="upload_ok" type="submit" value="确定"/>').addClass('ok');

	var btn = $('<div/>').addClass('upload-btn').append(ok);
	form.append(btn);
	
	form.submit(function(){
		if($('#upload_file').val() == ''){
			alert('请先把上传文件！');
			return false;
		}
		
		$(this).attr('uploading', true);
		$('#upload_ok').attr('disabled',true).attr('value','上传中，请稍等..');
		return true;					 
	});
	
	p.toolbar.append(a);
	a.show();
	
	return a;
}

FE.prototype.create_mask_panel = function(){
	var p = this;
	var wp = $('<div/>').hide().addClass('fe-mask-panel');	
	wp.width(p.iframe.offsetWidth).height(p.iframe.offsetHeight).css({
		top:0,
		left:0
	});	
	
	p.toolbar.append(wp);	
	wp.show();	
	return wp;
}

FE.prototype.create_progress_panel = function(){
	var p = this;
	
	var wp = $('<div/>').hide().addClass('fe-progress-panel');	
	var msg = $('<table/>').append($('<tbody/>').append($('<tr/>').append($('<td/>'))));
	
	$('td', msg).html('正在转换链接，请稍候..');
	wp.append(msg);
	
	p.toolbar.append(wp);
	wp.show();
	
	var x = p.iframe.offsetLeft + (p.iframe.offsetWidth - msg.width())/2;
	var y = p.iframe.offsetTop + (p.iframe.offsetHeight - msg.height())/2 - 70;
	wp.css({
		left: x,
		top: y
	});	
		
	return wp;
}